unit Ntdll;

interface

uses
  Windows;

type
  ULONG_PTR = ULONG;

  TProcessInfoClass = (
    ProcessBasicInformation = 0
    );

  TProcessBasicInformation = record
    Reserved1: Pointer;
    PebBaseAddress: Pointer;
    Reserved2: array[0..1] of Pointer;
    UniqueProcessId: ULONG_PTR;
    InheritedFromUniqueProcessId: ULONG_PTR;
  end;

  TSystemInformationClass = (
    SystemTimeOfDayInformation = 3,
    SystemProcessorTimes = 8
    );

  TSystemTimeOfDayInformation = record
    liKeBootTime: TLargeInteger;
    liKeSystemTime: TLargeInteger;
    liExpTimeZoneBias: TLargeInteger;
    uCurrentTimeZoneId: ULONG;
    dwReserved: DWORD;
  end;

  TSystemProcessorTimes = record
    liIdleTime: TLargeInteger;
    liKernelIdleTime: TLargeInteger;
    liUserOtherTime: TLargeInteger;
    dwSpare: array[0..5] of DWORD;
  end;

var
  NtQueryInformationProcess: function (ProcessHandle: THandle;
    ProcessInformationClass: TProcessInfoClass; ProcessInformation: Pointer;
    ProcesssInformationLength: ULONG; ReturnLength: PULONG): Longint; stdcall;
  NtQuerySystemInformation: function (
    SystemInformationClass: TSystemInformationClass;
    SystemInformation: Pointer; SystemInformationLength: ULONG;
    ReturnLength: PULONG): Longint; stdcall;

implementation

var
  Handle: THandle;
begin
  Handle := LoadLibrary('ntdll.dll');
  if Handle <> 0 then
  begin
    NtQueryInformationProcess := GetProcAddress(Handle,
        'NtQueryInformationProcess');
    NtQuerySystemInformation := GetProcAddress(Handle,
        'NtQuerySystemInformation');
  end;
end.
