unit Psapi;

interface

uses Windows;

type
  PHMODULE = ^HMODULE;

  TProcessMemoryCounters = packed record
    cb: DWORD;
    PageFaultCount: DWORD;
    PeakWorkingSetSize: DWORD;
    WorkingSetSize: DWORD;
    QuotaPeakPagedPoolUsage: DWORD;
    QuotaPagedPoolUsage: DWORD;
    QuotaPeakNonPagedPoolUsage: DWORD;
    QuotaNonPagedPoolUsage: DWORD;
    PagefileUsage: DWORD;
    PeakPagefileUsage: DWORD;
  end;
  PProcessMemoryCounters = ^TProcessMemoryCounters;

  TModuleInfo = packed record
    lpBaseOfDll: Pointer;
    SizeOfImage: DWORD;
    EntryPoint: Pointer;
  end;
  PModuleInfo = ^TModuleInfo;

var
  EnumProcesses: function (pProcessIds: PDWORD; cb: DWORD;
    pBytesReturned: PDWORD): BOOL; stdcall;
  EnumProcessModules: function (hProcess: THandle; lphModule: PHMODULE;
    cb: DWORD; lpcbNeeded: LPDWORD): BOOL; stdcall;
  GetMappedFileName: function (hProcess: THandle; lpv: Pointer;
    lpFileName: LPTSTR; nSize: DWORD): DWORD; stdcall;
  GetModuleBaseName: function (hProcess: THandle; hModule: HMODULE;
    lpBaseName: LPTSTR; nSize: DWORD): DWORD; stdcall;
  GetModuleFileNameEx: function (hProcess: THandle; hModule: HMODULE;
    lpFileName: LPTSTR; nSize: DWORD): DWORD; stdcall;
  GetModuleInformation: function (hProcess: THandle; hModule: HMODULE;
    lpmodinfo: PModuleInfo; cb: DWORD): BOOL; stdcall;
  GetProcessMemoryInfo: function (hProcess: THandle;
    ppsmemCounters: PProcessMemoryCounters; cb: DWORD): BOOL; stdcall;
  GetProcessImageFileName: function (hProcess: Thandle;
    lpImageFileName: LPTSTR; nSize:DWORD): DWORD; stdcall;

implementation

var
  Handle: THandle;
begin
  Handle := LoadLibrary('psapi.dll');
  if Handle <> 0 then
  begin
    EnumProcesses := GetProcAddress(Handle, 'EnumProcesses');
    EnumProcessModules := GetProcAddress(Handle, 'EnumProcessModules');
    GetMappedFileName := GetProcAddress(Handle, 'GetMappedFileNameA');
    GetModuleBaseName := GetProcAddress(Handle, 'GetModuleBaseNameA');
    GetModuleFileNameEx := GetProcAddress(Handle, 'GetModuleFileNameExA');
    GetModuleInformation := GetProcAddress(Handle, 'GetModuleInformation');
    GetProcessMemoryInfo := GetProcAddress(Handle, 'GetProcessMemoryInfo');
    GetProcessImageFileName :=
        GetProcAddress(Handle, 'GetProcessImageFileNameA'); // XP or later
  end;
end.
